module dfl.commondialog;

private import dfl.control, dfl.winapi, dfl.base, dfl.drawing;
private import dfl.application;

public import dfl.filedialog, dfl.folderdialog, dfl.colordialog;


abstract class CommonDialog // docmain
{
	abstract void reset();
	
	// Uses currently active window of the application as owner.
	abstract DialogResult showDialog();
	
	abstract DialogResult showDialog(IWin32Window owner);
	
	
	HelpEventHandler helpRequest;
	
	
	protected:
	
	// See the CDN_* Windows notification messages.
	LRESULT hookProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
	{
		switch(msg)
		{
			case WM_NOTIFY:
				{
					NMHDR* nmhdr;
					nmhdr = cast(NMHDR*)lparam;
					switch(nmhdr.code)
					{
						case CDN_HELP:
							{
								Point pt;
								GetCursorPos(&pt.point);
								onHelpRequest(new HelpEventArgs(pt));
							}
							break;
						
						default: ;
					}
				}
				break;
			
			default: ;
		}
		
		return 0;
	}
	
	
	// TODO: implement.
	//LRESULT ownerWndProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
	
	
	void onHelpRequest(HelpEventArgs ea)
	{
		helpRequest(this, ea);
	}
	
	
	abstract bool runDialog(HWND owner);
	
	
	package final void _cantrun()
	{
		throw new DflException("Error running dialog.");
	}
}

