﻿// To compile:
// 	dfl charformat -gui
// or
// 	dmd charformat dfl.lib -L/exet:nt/su:windows:4.0


private import dfl.all;


class MainForm: Form
{
	RichTextBox rtb;
	
	
	this()
	{
		text = "DFL charformat";
		size = Size(600, 400);
		windowState = FormWindowState.MAXIMIZED;
		
		with(rtb = new RichTextBox)
		{
			parent = this;
			font = new Font("Courier New", 10f); // Default font.
			backColor = Color(0xFF, 0xFF, 0xFF);
			foreColor = Color(0);
			dock = DockStyle.FILL;
			scrollBars = RichTextBoxScrollBars.VERTICAL;
			
			gotFocus ~= &rtb_gotFocus;
		}
		
		load ~= &form_load;
	}
	
	
	private void form_load(Object sender, EventArgs ea)
	{
		// Stream in formatted text by setting the selection formatting and then
		// setting the selected text.
		
		// If you want to apply formatting to existing text you would have to
		// select the text first using selectionStart and selectionLength.
		
		with(rtb)
		{
			selectionColor = Color(0);
			selectedText = "Then the developers said, ";
			
			selectionColor = Color(0xFF, 0, 0);
			selectionFont = new Font("Arial", 12f);
			selectedText = "\"DFL is wonderful\"";
			selectionFont = font; // Set the font back to the default rtb.font.
			
			selectionColor = Color(0);
			selectedText = " and proceeded to ";
			
			selectionFont = new Font("Courier New", 10f, FontStyle.ITALIC);
			selectedText = "astonish the ";
			selectionFont = new Font("Courier New", 10f, cast(FontStyle)(FontStyle.ITALIC | FontStyle.BOLD));
			selectedText = "world ";
			
			selectionFont = font; // Set the font back to the default rtb.font.
			selectedText = "with the app they developed.";
			
			selectionColor = Color(0);
			selectedText = "\r\n\r\nH";
			selectionSubscript = true;
			assert(selectionSubscript);
			selectedText = "2";
			selectionSubscript = false;
			assert(!selectionSubscript);
			selectedText = "0";
			
			selectedText = "\r\n\r\nx";
			selectionSuperscript = true;
			assert(selectionSuperscript);
			selectedText = "3";
			selectionSuperscript = false;
			assert(!selectionSuperscript);
			selectedText = " + 1";
		}
	}
	
	
	private void rtb_gotFocus(Object sender, EventArgs ea)
	{
		// Prevent the text from initially being highlighted when the form opens.
		rtb.selectionLength = 0;
		
		// Unregister this delegate from being called on focus events in the future.
		rtb.gotFocus.removeHandler(&rtb_gotFocus);
	}
}


int main()
{
	int result = 0;
	
	try
	{
		Application.run(new MainForm);
	}
	catch(Object o)
	{
		msgBox(o.toString(), "Fatal Error", MsgBoxButtons.OK, MsgBoxIcon.ERROR);
		
		result = 1;
	}
	
	return result;

}

