// Written by Christopher E. Miller
// This code is public domain.

// To compile:
// 	dfl mdi -gui
// or
// 	dmd mdi.d dfl.lib -L/exet:nt/su:windows:4.0


private import std.string;

private import dfl.all, dfl.utf;


class MainForm: Form
{
	uint docnum = 0;
	
	this()
	{
		text = "DFL MDI";
		startPosition = FormStartPosition.WINDOWS_DEFAULT_BOUNDS;
		
		MenuItem mi;
		menu = new MainMenu;
		
		with(mi = new MenuItem)
		{
			text = "New";
			
			click ~= &menubar_click;
		}
		menu.menuItems.add(mi);
		
		isMdiContainer = true;
		
		addChild();
	}
	
	
	final void addChild()
	{
		with(new Form)
		{
			text = "MDI child #" ~ std.string.toString(++docnum) ~ "/" ~ std.string.toString(this.mdiChildren.length + 1);
			mdiParent = this;
			show();
		}
	}
	
	
	private void menubar_click(Object sender, EventArgs ea)
	{
		addChild();
	}
}


int main()
{
	int result = 0;
	
	try
	{
		// Application initialization code here.
		
		Application.run(new MainForm);
	}
	catch(Object o)
	{
		msgBox(o.toString(), "Fatal Error", MsgBoxButtons.OK, MsgBoxIcon.ERROR);
		
		result = 1;
	}
	
	return result;
}

