// To compile:
// 	dfl tabs -gui
// or
// 	dmd tabs.d dfl.lib -L/exet:nt/su:windows:4.0


private import dfl.all;


class MainForm: Form
{
	TabControl tctrl;
	TextBox tab4box;
	
	
	this()
	{
		text = "Tabs";
		size = Size(380, 300);
		startPosition = FormStartPosition.CENTER_SCREEN;
		
		with(tctrl = new TabControl)
		{
			multiline = true;
			dock = DockStyle.FILL;
			
			TabPage tp;
			
			tp = new TabPage("Tab 1");
			tp.backColor = Color(0, 0, 0xDD);
			with(new Label)
			{
				backColor = tp.backColor;
				foreColor = Color(0xDD, 0xDD, 0xFF);
				bounds = Rect(20, 20, 400, 40);
				useMnemonic = false;
				font = new Font("Arial", 11f, FontStyle.BOLD);
				text = Environment.osVersion.toString();
				parent = tp;
			}
			tabPages.add(tp);
			
			tabPages.add("Tab 2");
			
			tp = new TabPage("Tab 3");
			tp.backColor = Color(0, 0xDD, 0);
			with(new Label)
			{
				backColor = tp.backColor;
				foreColor = Color(0);
				bounds = Rect(20, 20, 400, 40);
				useMnemonic = false;
				font = new Font("Courier New", 10f, FontStyle.BOLD);
				text = Environment.machineName ~ "\\" ~ Environment.userName;
				parent = tp;
			}
			tabPages.add(tp);
			
			tp = new TabPage("Tab 4");
			tp.borderStyle = BorderStyle.FIXED_3D;
			with(tab4box = new TextBox)
			{
				text = tp.text;
				location = Point(20, 20);
				parent = tp;
			}
			Button btn;
			with(btn = new Button)
			{
				text = "Text";
				location = Point(tab4box.right + 4, 20);
				parent = tp;
				click ~= &acceptButton_click;
			}
			this.acceptButton = btn;
			tabPages.add(tp);
			
			tp = new TabPage("Tab 5");
			tp.backColor = Color(0xDD, 0, 0);
			tp.dockPadding.all = 32;
			with(new TextBox)
			{
				text = "This is tab number 5!";
				multiline = true;
				acceptsReturn = true;
				dock = DockStyle.FILL;
				parent = tp;
			}
			tabPages.add(tp);
			
			parent = this;
			
			selectedIndexChanging ~= &tctrl_selectedIndexChanging;
		}
	}
	
	
	private void acceptButton_click(Object sender, EventArgs ea)
	{
		tctrl.tabPages[3].text = tab4box.text;
	}
	
	
	private void tctrl_selectedIndexChanging(Object sender, CancelEventArgs ea)
	{
		if(tctrl.selectedIndex == 1)
		{
			if(DialogResult.OK == msgBox(this, "Do not leave Tab 2, do not collect $200", text, MsgBoxIcon.INFORMATION, MsgBoxButtons.OK_CANCEL))
				ea.cancel = true;
		}
	}
}


int main()
{
	Application.run(new MainForm);
	return 0;
}

