// To compile:
// 	dfl tray -gui
// or
// 	dmd tray tray.res dfl.lib -L/exet:nt/su:windows:4.0


private import std.c.windows.windows;

private import dfl.all;


const char* IDI_ICON1 = cast(char*)101;


int main()
{
	Form f;
	ContextMenu cmenu;
	MenuItem mpop, mi;
	NotifyIcon ni;
	Button btn;
	
	f = new Form;
	f.text = "DFL tray icon test.";
	f.icon = new Icon(LoadIconA(GetModuleHandleA(null), IDI_ICON1));
	f.visible = false;
	
	btn = new Button;
	btn.text = "Hide";
	btn.click ~= delegate(Object sender, EventArgs ea)
		{
			f.hide();
			ni.visible = true;
		};
	btn.parent = f;
	
	cmenu = new ContextMenu;
	
	mpop = new MenuItem;
	mpop.text = "&Action";
	mpop.index = 0;
	cmenu.menuItems.add(mpop);
	
	mi = new MenuItem;
	mi.text = "&Show Form";
	mi.click ~= delegate(Object sender, EventArgs ea)
		{
			f.show();
		};
	mi.index = 0;
	mpop.menuItems.add(mi);
	
	mi = new MenuItem;
	mi.index = 1;
	mi.text = "&Hide Icon";
	mi.click ~= delegate(Object sender, EventArgs ea)
		{
			if(!f.visible)
				f.visible = true;
			ni.visible = false;
		};
	mpop.menuItems.add(mi);
	
	mi = new MenuItem;
	mi.text = "-"; // Separator.
	mi.index = 1;
	cmenu.menuItems.add(mi);
	
	mi = new MenuItem;
	mi.text = "E&xit";
	mi.click ~= delegate(Object sender, EventArgs ea)
		{
			Application.exitThread();
		};
	mi.index = 2;
	cmenu.menuItems.add(mi);
	
	ni = new NotifyIcon;
	ni.text = f.text;
	ni.icon = f.icon;
	ni.contextMenu = cmenu;
	ni.visible = true;
	
	Application.run(new ApplicationContext(f));
	
	return 0;
}

